package gonganxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type street struct {
	Table
	modify string `name:"modify street_info" role:"void"`
	list   string `name:"list street_name auto" role:"void"`
}

func (s street) FindOrCreateByName(m *ice.Message, arg ...string) {
	if msg := m.Cmd(s, s.Select, model.CITY_UID, arg[1], model.NAME, arg[3]); msg.Length() == 0 {
		msg := m.Cmd(s, s.Insert, model.CITY_UID, arg[1], model.NAME, arg[3])
		arg[2], arg[3] = model.STREET_UID, msg.Result()
	} else {
		arg[2], arg[3] = model.STREET_UID, msg.Append(model.UID)
	}
}
func (s street) Modify(m *ice.Message, arg ...string) {
	s.Update(m, kit.Dict(model.INFO, m.Option(model.STREET_INFO)), model.NAME, m.Option(model.STREET_NAME))
}
func (s street) List(m *ice.Message, arg ...string) {
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m, arg...)
		}
	} else {
		msg := s.Select(m.Spawn(), model.NAME, arg[0])
		m.Option(model.STREET_NAME, msg.Append(model.NAME))
		m.Option(model.STREET_INFO, msg.Append(model.INFO))
		m.Option(model.STREET_AVATAR, msg.Append(model.AVATAR))
		m.Option(model.STREET_BACKGROUND, msg.Append(model.BACKGROUND))
		msg.Table(func(value ice.Maps) {
			if value[model.AUTH_UID] != "" {
				m.Cmdy("web.team.renzhengshouquan.auth", value[model.AUTH_UID])
			}
		})
		kit.If(m.IsTech(), func() { m.Action(s.Modify) })
		m.Display("")
	}
}

func init() { ice.TeamCtxCmd(street{}) }
