package yuehaoxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/mdb"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type call struct {
	Schedule
	list string `name:"list queue_uid uid reception_uid auto"`
}

func (s call) Call(m *ice.Message, arg ...string) { m.Cmdy(s.Schedule, m.ActionKey(), arg) }
func (s call) List(m *ice.Message, arg ...string) {
	role := UserQueueRole(kit.Int(m.Option(model.USER_ROLE)))
	if len(arg) == 1 {
		if role != UserQueueVisitor {
			s.SelectByStatus(m.Options(mdb.ORDER, model.TAKE_TIME), arg[0], kit.Format(ScheduleTake))
			kit.If(m.Length() == 0, func() { m.Echo(m.Trans("wait take", "等待取号")) }, func() { m.Action(s.Call) })
		}
	} else if len(arg) == 2 {
		s.Schedule.List(m, arg[0], arg[1])
		if role != UserQueueVisitor {
			m.Action(s.Call)
		}
	} else if len(arg) == 3 {
		if role != UserQueueVisitor {
			s.Schedule.Select(m, model.QUEUE_UID, arg[0], model.RECEPTION_UID, arg[2], model.STATUS, kit.Format(ScheduleTake)).Action(s.Call)
		}
	}
}
func (s call) Expire(m *ice.Message, arg ...string) { m.Cmdy(s.Schedule, m.ActionKey(), arg) }
func (s call) Finish(m *ice.Message, arg ...string) { m.Cmdy(s.Schedule, m.ActionKey(), arg) }

func init() { ice.TeamCtxCmd(call{}) }
