package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	TYPE            = "type"
	STATUS          = "status"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_ROLE       = "user_role"
	USER_QUEUE_ROLE = "user_queue_role"
	QUEUE_UID       = "queue_uid"
	QUEUE_NAME      = "queue_name"
	QUEUE_TYPE      = "queue_type"
	RECEPTION_UID   = "reception_uid"
	RECEPTION_NAME  = "reception_name"
	VOLUME_UID      = "volume_uid"
	VOLUME_AMOUNT   = "volume_amount"
	SCHEDULE_UID    = "schedule_uid"
	SCHEDULE_STATUS = "schedule_status"
	COMPANY_UID     = "company_uid"
	CALL_UID        = "call_uid"
	BEGIN_TIME      = "begin_time"
	END_TIME        = "end_time"
	CANCEL_TIME     = "cancel_time"
	TAKE_TIME       = "take_time"
	CALL_TIME       = "call_time"
	FINISH_TIME     = "finish_time"
	EXPIRE_TIME     = "expire_time"
	AMOUNT          = "amount"
	COUNT           = "count"
	EXPIRE          = "expire"
	FINISH          = "finish"
)

type UserQueue struct {
	db.ModelUserPlace
	QueueUID string `gorm:"type:char(32);index"`
}
type Queue struct {
	db.ModelPlace
	CompanyUID string `gorm:"type:char(32);index"`
}
type Reception struct {
	db.ModelWithUID
	QueueUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32);index"`
	Name     string `gorm:"type:varchar(64)"`
}
type Volume struct {
	db.ModelWithUID
	QueueUID     string `gorm:"type:char(32);index:idx_queue"`
	ReceptionUID string `gorm:"type:char(32);index:idx_queue"`
	BeginTime    db.Time
	EndTime      db.Time
	Amount       int `gorm:"default:0"`
	Count        int `gorm:"default:0"`
	Expire       int `gorm:"default:0"`
	Finish       int `gorm:"default:0"`
}
type Schedule struct {
	db.ModelWithUID
	QueueUID     string `gorm:"type:char(32);index:idx_queue"`
	ReceptionUID string `gorm:"type:char(32);index:idx_queue"`
	VolumeUID    string `gorm:"type:char(32);index:idx_queue"`
	UserUID      string `gorm:"type:char(32);index"`
	CallUID      string `gorm:"type:char(32);index"`
	CancelTime   db.Time
	TakeTime     db.Time
	CallTime     db.Time
	ExpireTime   db.Time
	FinishTime   db.Time
	Status       uint8 `gorm:"default:0"`
}

func init() { db.CmdModels("", &UserQueue{}, &Queue{}, &Reception{}, Volume{}, &Schedule{}) }
